package cn.ischoolcode.javabook.scene10;

/* 
 * 爱校码
 * http://www.ischoolcode.cn/
 *  
 * @author zcj
 */

import java.io.*;
public class IOStreamApp {
    public static void main(String[] args) {
		try {
			/**缓冲输入的文件*/
			File file = new File("e://temp//zcj.dat");
			BufferedReader in1 =
				new BufferedReader(
					new InputStreamReader(new FileInputStream(file)));

			String strTemp;
			String str1 = null;
			while ((strTemp = in1.readLine()) != null) {
				str1 += strTemp + "/n";
			}
			in1.close();
			/**从内存输入*/
			StringReader in2 = new StringReader(str1);
			int c;
			while ((c = in2.read()) != -1) {
				System.out.println((char) c);
			}
			/**格式化内存输入*/
			try {
				DataInputStream in3 =
					new DataInputStream(new StringBufferInputStream(str1));

				while (true) {
					System.out.println((char) in3.readByte());
				}
			} catch (EOFException e) {
				System.out.println("已到达流的末尾");
			}
			/**行号与文件输出*/
			try {
				LineNumberReader li = new LineNumberReader(in2);
				BufferedReader in4 = new BufferedReader(li);
				PrintWriter out1 =
					new PrintWriter(
						new BufferedWriter(
							new FileWriter(new File("out.txt"))));
				while ((strTemp = in4.readLine()) != null) {
					out1.println("行:" + li.getLineNumber() + strTemp);
				}
				out1.close();
			} catch (EOFException e) {
				System.out.println("已到达流的末尾");
			}
			/**存储与获取数据*/
			try {
				DataOutputStream out2 =
					new DataOutputStream(
						new BufferedOutputStream(
							new FileOutputStream(new File("Data.txt"))));
				out2.writeDouble(42.67);
				out2.writeChars("Hello World");
				out2.close();
				DataInputStream in5=
				    new DataInputStream(
				        new BufferedInputStream(
				           new FileInputStream(
				              new File("Data.txt"))));
				BufferedReader in6=
				    new BufferedReader(
				        new InputStreamReader(in5));
			    /**必须使用DataInputStream获取数据*/
			    System.out.println(in5.readDouble());
			    /**readline()需要使用缓冲流*/
			    System.out.println(in6.readLine());
			} catch (EOFException e) {
				System.out.println("已到达流的末尾");
			}
           /**随机访问读写*/
            RandomAccessFile raf=
                    new RandomAccessFile("rafdata.dat","rw");
            for (int i=0; i<6;i++){
                raf.writeDouble(i*1.8);                
            }
            raf.close();
            raf= new RandomAccessFile("rafdata.dat","r");
            for(int i=0; i<6;i++){
                System.out.println(i+"值："+raf.readDouble());                            
            }
            raf.close();			 			
		} catch (FileNotFoundException fe) {
			System.out.println("指定的文件不存在！");
		} catch (IOException ioe) {
			System.out.println("IO操作错误！");
		} catch (Exception e) {
			System.out.println("出现异常！");
		}
	 }
}